<?php
namespace Models;

class android_inpas {
  public $f3, $sets, $web, $config;
  public $errors=array(
    -1=>'Неизвестная ошибка',
    0=>'DC не смог передать ответ от терминала. Возможная причина, внутренняя ошибка DC',
    1=>'Истекло время исполнения операции. Устанавливаемое полем «timeout» в запросе',
    3=>'Общая ошибка, ошибка параметров DC, не поддерживаемый метод HTTP,
неизвестная ошибка, ошибка во время работы DC',
    4=>'Ошибка поля или ошибка запроса, как между кассой и DC, так и между DC и
терминалом',
    13=>'Ошибка обмена данными между DC и терминалом. Возможная причина в отсутствии
устройства или ответ не по протоколу SA',
    15=>'Обмен данными прерван, например, выключение DC, мониторинг подключения
устройства или отменен другим обменом',
    16=>'Устройство занято, например, занято другим обменом'
  );

  function __construct($f3, $sets, $config) {
    $this->f3=$f3;
    $this->sets=$sets;
    $this->web=\Web::instance();
    if(!$config['Sale']) $config['Sale']=1;
    if(!$config['Return']) $config['Return']=29;
    if(!$config['Cancel']) $config['Cancel']=4;
    if(!$config['Close']) $config['Close']=59;
    if(!$config['X']) $config['X']=63;
    if(!$config['Test']) $config['Test']=26;
    if(!$config['URL']) $config['URL']='http://localhost:9015';
        $this->config=$config;
  }

  // Отправка задания
  function send_cmd($xml, $ok_field=15) {
    $options=array(
      'method'=>'POST',
      'header'=>array(
        'Accept: */*',
        'Content-Type: text/xml; charset=windows-1251'
      ),
      'content'=>$xml
    );
    $url=$this->config['URL'].'/requests';
    $res=$this->web->request($url, $options);
    if(mb_strpos($res['headers'][0], '200')!==false || mb_strpos($res['headers'][0], '201')!==false) {
      $xml=new \SimpleXMLElement($res['body']);
      if(isset($xml->errorcode)) {
        if(isset($this->errors[$xml->errorcode])) {
          $error=$this->errors[$xml->errorcode];
        }
        else {
          $error=$this->errors[-1];
        }
        return array(
          'success'=>false,
          'txt'=>$error
        );
      }
      foreach ($xml->field as $key => $field) {
        if($field['id']=='10') {
          $pan=trim($field);
        }

        if($field['id']=='13') {
          $authcode=trim($field);
        }

        if($field['id']=='14') {
          $transid=trim($field);
        }

        if($field['id']=='19') {
          $status_txt=trim($field);
        }

        if($field['id']==(string)$ok_field) {
          if((int)trim($field)===1) {
            $success=true;
          }
          else {
            $success=false;
            $status_code=trim($field);
          }
        }

        if($field['id']=='90') {
          if (!preg_match('//u', $field)) {
            $field=iconv("windows-1251","utf-8",$field);
          }
          $slips=explode('0xDA^^', $field);
          $slips[0]=str_replace('0xDF^^', '' , $slips[0]);
          if(!$slips[1]) {
            $slips[1]=$slips[0];
          }
        }
      }

      if($success) {
        return array(
          'success'=>true,
          'txt'=>nl2br($slips[0]),
          'slip'=>nl2br($slips[1]),
          'pan'=>$pan,
          'transid'=>$transid,
          'authcode'=>$authcode
        );
      }
      else {
        return array(
          'success'=>false,
          'txt'=>nl2br($status_txt).'<br>Код статуса: '.$status_code
        );
      }
    }


    return array(
      'success'=>false,
      //'txt'=>implode('; ', $res['body'])
      'txt'=>$res['body']
    );
  }

  function ticket($type, $sum, $return_bt=null) {
    if($type=='sale') {
      $operation=$this->config['Sale'];
    }
    elseif($type=='return') {
      $operation=$this->config['Return'];
    }
    else {
      $operation=$this->config['Cancel'];
    }

    $xml="<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n";
    $xml.="<request>\n";
    $xml.="<field id=\"00\">".($sum*100)."</field>\n";
    $xml.="<field id=\"04\">643</field>\n";
    if($type=='return') {
      $xml.="<field id=\"13\">".$return_bt['authcode']."</field>\n";
    }
    $xml.="<field id=\"25\">".$operation."</field>\n";
    if($type!='sale') {
      $xml.="<field id=\"26\">".$return_bt['transid']."</field>\n";
    }
    if($this->config['TerminalID']) {
      $xml.="<field id=\"27\">".$this->config['TerminalID']."</field>\n";
    }
    $xml.="</request>\n";
    return $this->send_cmd($xml);
  }

  function z() {
    $xml="<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n";
    $xml.="<request>\n";
    $xml.="<field id=\"25\">".$this->config['Close']."</field>\n";
    if($this->config['TerminalID']) {
      $xml.="<field id=\"27\">".$this->config['TerminalID']."</field>\n";
    }
    $xml.="</request>\n";
    return $this->send_cmd($xml);
  }

  function x() {
    $xml="<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n";
    $xml.="<request>\n";
    $xml.="<field id=\"25\">".$this->config['X']."</field>\n";
    $xml.="<field id=\"65\">20</field>\n";
    if($this->config['TerminalID']) {
      $xml.="<field id=\"27\">".$this->config['TerminalID']."</field>\n";
    }
    $xml.="</request>\n";
    return $this->send_cmd($xml, 67);
  }

  function testconnection() {
    $xml="<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n";
    $xml.="<request>\n";
    $xml.="<field id=\"00\">10</field>\n";
    $xml.="<field id=\"04\">643</field>\n";
    $xml.="<field id=\"25\">".$this->config['Test']."</field>\n";
    if($this->config['TerminalID']) {
      $xml.="<field id=\"27\">".$this->config['TerminalID']."</field>\n";
    }
    $xml.="</request>\n";
    return $this->send_cmd($xml);
  }
}
